Subject: Re: IPv6 FIB related crash with MACVLANs in 3.9.11+ kernel.

From: Ben Greear <[email-masked]>
Date: Mon, 29 Sep 2014 14:24:54 -0700

On 09/29/2014 01:39 PM, Cong Wang wrote:
> On Mon, Sep 29, 2014 at 12:48 PM, Ben Greear <[email-masked]> wrote:
>>
>> We are going to be running up to 20 concurrent scripts that
>> will be dumping routes & ips, and configuring ip addresses
>> and routes during bringup.
>>
>> I don't have a simple stand-alone way to reproduce this,
>> but at least when we reported the problem is was very easy
>> for us to reproduce with our tool.
>>
>> Maybe 20 scripts running in parallel that randomly configured and dumped routes
>> and ip addresses on random interfaces would do the trick?
>>
> 
> I think the most important question is why is this related with macvlan?
> IPv6 is L3 while macvlan pure L2, if this is a IPv6 routing bug, it should
> not be limited to macvlan.

We saw it using mac-vlans on top of ixgbe.  Probably it can be reproduced
elsewhere, but since we had a good test case, we didn't bother trying lots
of other combinations.

Just enabling some debug code caused the problem to be much harder
to reproduce, so it is probably some sort of race.  Maybe lots of mac-vlans
make it easier to hit.

> What does your IPv6 routing table look like? And how do you configure those
> macvlan interfaces?

Each interface would have it's own routing table, with at least as subnet
route.  I'm not sure we were adding a default gateway or not.

The main routing table would also have some auto-created routes
I think.

It is configured using 'ip' to add and dump routes.

Thanks,
Ben

-- 
Ben Greear <[email-masked]>
Candela Technologies Inc  http://www.candelatech.com